import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import * as wjCore from '@mescius/wijmo';
import * as wjInput from '@mescius/wijmo.input';
import * as wjPdf from '@mescius/wijmo.pdf';
import * as wjGridPdf from '@mescius/wijmo.grid.pdf';
import * as wjGridXlsx from '@mescius/wijmo.grid.xlsx';
import { MultiRow } from '@mescius/wijmo.grid.multirow';
import { TransposedMultiRow } from '@mescius/wijmo.grid.transposedmultirow';
import { generateAppData } from './data';
//
document.readyState === 'complete' ? init() : window.onload = init;
//
function init() {
let appData = generateAppData();
let orders = appData.orders;
let layoutDefs = appData.layoutDefs;
let currentLayout = appData.layoutDefs.currentItem;
let trnMultirow = new TransposedMultiRow('#trnMultirow', {
itemsSource: orders,
layoutDefinition: currentLayout.def
});
let ordMultirow = new MultiRow('#ordMultirow', {
itemsSource: orders,
layoutDefinition: currentLayout.def
});
let ldComboBox = new wjInput.ComboBox('#ldComboBox', {
itemsSource: layoutDefs,
displayMemberPath: 'name'
});
//
updateDescriptions();
layoutDefs.currentChanged.addHandler(() => {
currentLayout = appData.layoutDefs.currentItem;
updateMultirow();
updateDescriptions();
});
//
document.getElementById('btnExportToExcel').addEventListener('click', function () {
wjGridXlsx.FlexGridXlsxConverter.saveAsync(trnMultirow, {
includeRowHeaders: true
}, 'FlexGrid.xlsx');
});
//
document.getElementById('btnExportToPDF').addEventListener('click', function () {
wjGridPdf.FlexGridPdfConverter.export(trnMultirow, 'FlexGrid.pdf', {
documentOptions: {
pageSettings: {
layout: wjPdf.PdfPageOrientation.Landscape
}
},
scaleMode: wjGridPdf.ScaleMode.ActualSize
});
});
//
function updateMultirow() {
trnMultirow.layoutDefinition = currentLayout.def;
ordMultirow.layoutDefinition = currentLayout.def;
}
//
function updateDescriptions() {
wjCore.setText(document.querySelector('#mainDesc'), currentLayout.descriptions.main);
wjCore.setText(document.querySelector('#trnDesc'), currentLayout.descriptions.transposedView);
wjCore.setText(document.querySelector('#ordDesc'), currentLayout.descriptions.ordinaryView);
}
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo TransposedMultiRow Layout Definition</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div class="container-fluid">
<label>Layout option: <div id="ldComboBox"></div></label>
<p id="mainDesc"></p>
<label>Transposed MultiRow</label>
<p id="trnDesc"></p>
<div id="trnMultirow"></div>
<div>
<button id="btnExportToExcel" class="btn btn-outline-secondary">
Export To Excel
</button>
<button id="btnExportToPDF" class="btn btn-outline-secondary">
Export To PDF
</button>
</div>
<label>Ordinary MultiRow</label>
<p id="ordDesc"></p>
<div id="ordMultirow"></div>
</div>
</body>
</html>
import * as wjCore from '@mescius/wijmo';
import * as wjGrid from '@mescius/wijmo.grid';
//
export function generateAppData() {
// create some data
let appData = {}, customers = [], firstNames = 'Aaron,Paul,John,Mark,Sue,Tom,Bill,Joe,Tony,Brad,Frank,Chris,Pat'.split(','), lastNames = 'Smith,Johnson,Richards,Bannon,Wong,Peters,White,Brown,Adams,Jennings'.split(','), cities = 'York,Paris,Rome,Cairo,Florence,Sidney,Hamburg,Vancouver'.split(','), states = 'SP,RS,RN,SC,CS,RT,BC'.split(',');
for (let i = 0; i < 50; i++) {
let first = randArray(firstNames), last = randArray(lastNames);
customers.push({
id: i,
name: first + ' ' + last,
address: randBetween(100, 10000) + ' ' + randArray(lastNames) + ' St.',
city: randArray(cities),
state: randArray(states),
zip: wjCore.format('{p1:d5}-{p2:d3}', {
p1: randBetween(10000, 99999),
p2: randBetween(100, 999)
}),
email: first + '.' + last + '@gmail.com',
phone: wjCore.format('{p1:d3}-{p2:d4}', {
p1: randBetween(100, 999),
p2: randBetween(1000, 9999)
})
});
}
let cityMap = new wjGrid.DataMap(cities);
let shippers = [
{ id: 0, name: 'Speedy Express', email: 'speedy@gmail.com', phone: '431-3234', express: true },
{ id: 1, name: 'Flash Delivery', email: 'flash@gmail.com', phone: '431-6563', express: true },
{ id: 2, name: 'Logitrax', email: 'logitrax@gmail.com', phone: '431-3981', express: false },
{ id: 3, name: 'Acme Inc', email: 'acme@gmail.com', phone: '431-3113', express: false }
];
let orders = [];
let today = new Date();
for (let i = 0; i < 20; i++) {
let shipped = wjCore.DateTime.addDays(today, -randBetween(1, 3000));
orders.push({
id: i,
date: wjCore.DateTime.addDays(shipped, -randBetween(1, 5)),
shippedDate: shipped,
amount: randBetween(10000, 500000) / 100,
customer: clone(randArray(customers)),
shipper: clone(randArray(shippers))
});
}
//
function randBetween(min, max) {
return Math.floor(Math.random() * (max - min + 1) + min);
}
//
function randArray(arr) {
return arr[randBetween(0, arr.length - 1)];
}
// shallow copy
function clone(obj) {
if (wjCore.isFunction(Object.assign)) { // IE does not support it
return Object.assign({}, obj);
}
let clone = {};
for (let prop in obj) {
if (obj.hasOwnProperty(prop)) {
clone[prop] = obj[prop];
}
}
return clone;
}
// expose orders CollectionView to the app
appData.orders = new wjCore.CollectionView(orders);
// expose grouped orders CollectionView to the app
appData.groupedOrders = new wjCore.CollectionView(orders, {
groupDescriptions: [
'customer.city'
]
});
// expose paged orders CollectionView to the app
appData.pagedOrders = new wjCore.CollectionView(orders, {
pageSize: 4
});
// expose addNew oders CollectionView to the app
appData.addNewOrders = new wjCore.CollectionView(orders, {
newItemCreator: function () {
return {
customer: {},
shipper: {}
};
},
});
appData.addNewOrders.moveCurrentToLast();
// refresh views when data source changes
let ordersRefreshing = false;
appData.orders.collectionChanged.addHandler(function () {
ordersRefreshing = true;
if (!pagedOrdersRefreshing) {
appData.pagedOrders.refresh();
}
if (!groupedOrdersRefreshing) {
appData.groupedOrders.refresh();
}
if (!addNewOrdersRefreshing) {
appData.addNewOrders.refresh();
}
ordersRefreshing = false;
});
// addNew orders
let addNewOrdersRefreshing = false;
appData.addNewOrders.collectionChanged.addHandler(function () {
addNewOrdersRefreshing = true;
if (!ordersRefreshing) {
appData.orders.refresh();
}
if (!pagedOrdersRefreshing) {
appData.pagedOrders.refresh();
}
if (!groupedOrdersRefreshing) {
appData.groupedOrders.refresh();
}
addNewOrdersRefreshing = false;
});
// grouped orders
let groupedOrdersRefreshing = false;
appData.groupedOrders.collectionChanged.addHandler(function () {
groupedOrdersRefreshing = true;
if (!ordersRefreshing) {
appData.orders.refresh();
}
if (!pagedOrdersRefreshing) {
appData.pagedOrders.refresh();
}
if (!addNewOrdersRefreshing) {
appData.addNewOrders.refresh();
}
groupedOrdersRefreshing = false;
});
// paged orders
let pagedOrdersRefreshing = false;
appData.pagedOrders.collectionChanged.addHandler(function () {
pagedOrdersRefreshing = true;
if (!ordersRefreshing) {
appData.orders.refresh();
}
if (!addNewOrdersRefreshing) {
appData.addNewOrders.refresh();
}
if (!groupedOrdersRefreshing) {
appData.groupedOrders.refresh();
}
pagedOrdersRefreshing = false;
});
// sample layout definitions
appData.ldOneLine = [
{ cells: [{ binding: 'id', header: 'ID', cssClass: 'id', isReadOnly: true }] },
{ cells: [{ binding: 'date', header: 'Ordered' }] },
{ cells: [{ binding: 'shippedDate', header: 'Shipped' }] },
{ cells: [{ binding: 'amount', header: 'Amount', format: 'c', cssClass: 'amount' }] },
{ cells: [{ binding: 'customer.name', header: 'Customer' }] },
{ cells: [{ binding: 'customer.address', header: 'Address', wordWrap: true }] },
{ cells: [{ binding: 'customer.city', header: 'City', dataMap: cityMap }] },
{ cells: [{ binding: 'customer.state', header: 'State', width: 45 }] },
{ cells: [{ binding: 'customer.zip', header: 'Zip' }] },
{ cells: [{ binding: 'customer.email', header: 'Customer Email', cssClass: 'email' }] },
{ cells: [{ binding: 'customer.phone', header: 'Customer Phone' }] },
{ cells: [{ binding: 'shipper.name', header: 'Shipper' }] },
{ cells: [{ binding: 'shipper.email', header: 'Shipper Email', cssClass: 'email' }] },
{ cells: [{ binding: 'shipper.phone', header: 'Shipper Phone' }] },
{ cells: [{ binding: 'shipper.express', header: 'Express' }] }
];
appData.ldThreeLines = [
{
header: 'Order', colspan: 3, cells: [
{ binding: 'id', header: 'ID', rowspan: 2, cssClass: 'id' },
{ binding: 'amount', header: 'Amount', format: 'c', rowspan: 2, cssClass: 'amount' },
{ binding: 'date', header: 'Ordered' },
{ binding: 'shippedDate', header: 'Shipped' }
]
},
{
header: 'Customer', colspan: 3, cells: [
{ binding: 'customer.name', header: 'Name' },
{ binding: 'customer.address', header: 'Address', rowspan: 2 },
{ binding: 'customer.city', header: 'City', dataMap: cityMap },
{ binding: 'customer.email', header: 'EMail', rowspan: 2, cssClass: 'email' },
{ binding: 'customer.state', header: 'State', width: 45 },
{ binding: 'customer.phone', header: 'Phone' },
{ binding: 'customer.zip', header: 'Zip' },
]
},
{
header: 'Shipper', colspan: 3, cells: [
{ binding: 'shipper.name', header: 'Shipper' },
{ binding: 'shipper.email', header: 'EMail', cssClass: 'email' },
{ binding: 'shipper.express', header: 'Express' }
]
}
];
appData.layoutDefs = new wjCore.CollectionView([
{
name: 'Basic layout',
descriptions: {
main: 'This layout is divided into three groups: order, customer, and shipper. Each group consists of multiple properties and spans three columns.',
transposedView: 'This view uses three columns per record, and different number of rows per group.',
ordinaryView: 'This view uses the same number of rows per record, and three columns per group.'
},
def: appData.ldThreeLines
},
{
name: 'Grid layout',
descriptions: {
main: 'This layout is like a grid view. Each group consists of single property and spans one column.',
transposedView: 'This view corresponds to transposed grid view in which columns represent records.',
ordinaryView: 'This view corresponds to traditional grid view in which rows represent records.'
},
def: appData.ldOneLine
}
]);
return appData;
}
.wj-transposed-multirow {
height: 300px;
margin: 6px 0;
}
.wj-multirow {
height: 400px;
margin: 6px 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.52-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
'bootstrap.css': 'pcdn:bootstrap@5.3.8/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useRef, useState } from 'react';
import useEvent from 'react-use-event-hook';
import * as wjInput from '@mescius/wijmo.react.input';
import * as wjPdf from '@mescius/wijmo.pdf';
import * as wjGridPdf from '@mescius/wijmo.grid.pdf';
import * as wjGridXlsx from '@mescius/wijmo.grid.xlsx';
import { MultiRow } from '@mescius/wijmo.react.grid.multirow';
import { TransposedMultiRow } from '@mescius/wijmo.react.grid.transposedmultirow';
import './app.css';
import { data } from './data';
function App() {
const [currentLayout, setCurrentLayout] = useState(data.layoutDefs.currentItem);
const trnMultirowRef = useRef(null);
const initializeGrid = useEvent((trnMultirow) => {
trnMultirowRef.current = trnMultirow;
data.layoutDefs.currentChanged.addHandler(() => {
setCurrentLayout(data.layoutDefs.currentItem);
});
});
const exportToExcel = () => {
if (trnMultirowRef.current) {
wjGridXlsx.FlexGridXlsxConverter.saveAsync(trnMultirowRef.current, {
includeRowHeaders: true
}, 'FlexGrid.xlsx');
}
};
const exportToPdf = () => {
if (trnMultirowRef.current) {
wjGridPdf.FlexGridPdfConverter.export(trnMultirowRef.current, 'FlexGrid.pdf', {
documentOptions: {
pageSettings: {
layout: wjPdf.PdfPageOrientation.Landscape
}
},
scaleMode: wjGridPdf.ScaleMode.ActualSize
});
}
};
return (<div className="container-fluid">
<label>
Layout option:
<wjInput.ComboBox itemsSource={data.layoutDefs} displayMemberPath="name"/>
</label>
<p>{currentLayout.descriptions.main}</p>
<label>Transposed MultiRow</label>
<p>{currentLayout.descriptions.transposedView}</p>
<TransposedMultiRow itemsSource={data.orders} layoutDefinition={currentLayout.def} initialized={initializeGrid}/>
<div>
<button onClick={exportToExcel} className="btn btn-outline-secondary">Export To Excel</button>
<button onClick={exportToPdf} className="btn btn-outline-secondary">Export To PDF</button>
</div>
<label>Ordinary MultiRow</label>
<p>{currentLayout.descriptions.ordinaryView}</p>
<MultiRow itemsSource={data.orders} layoutDefinition={currentLayout.def}/>
</div>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Wijmo TransposedMultiRow Layout Definition</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.19.40/dist/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.wj-transposed-multirow {
height: 300px;
margin: 6px 0;
}
.wj-multirow {
height: 400px;
margin: 6px 0;
}
import * as wjCore from '@mescius/wijmo';
import * as wjGrid from '@mescius/wijmo.grid';
function getData() {
// create some data
let appData = {}, customers = [], firstNames = 'Aaron,Paul,John,Mark,Sue,Tom,Bill,Joe,Tony,Brad,Frank,Chris,Pat'.split(','), lastNames = 'Smith,Johnson,Richards,Bannon,Wong,Peters,White,Brown,Adams,Jennings'.split(','), cities = 'York,Paris,Rome,Cairo,Florence,Sidney,Hamburg,Vancouver'.split(','), states = 'SP,RS,RN,SC,CS,RT,BC'.split(',');
for (let i = 0; i < 50; i++) {
let first = randArray(firstNames), last = randArray(lastNames);
customers.push({
id: i,
name: first + ' ' + last,
address: randBetween(100, 10000) + ' ' + randArray(lastNames) + ' St.',
city: randArray(cities),
state: randArray(states),
zip: wjCore.format('{p1:d5}-{p2:d3}', {
p1: randBetween(10000, 99999),
p2: randBetween(100, 999)
}),
email: first + '.' + last + '@gmail.com',
phone: wjCore.format('{p1:d3}-{p2:d4}', {
p1: randBetween(100, 999),
p2: randBetween(1000, 9999)
})
});
}
let cityMap = new wjGrid.DataMap(cities);
let shippers = [
{ id: 0, name: 'Speedy Express', email: 'speedy@gmail.com', phone: '431-3234', express: true },
{ id: 1, name: 'Flash Delivery', email: 'flash@gmail.com', phone: '431-6563', express: true },
{ id: 2, name: 'Logitrax', email: 'logitrax@gmail.com', phone: '431-3981', express: false },
{ id: 3, name: 'Acme Inc', email: 'acme@gmail.com', phone: '431-3113', express: false }
];
let orders = [];
let today = new Date();
for (let i = 0; i < 20; i++) {
let shipped = wjCore.DateTime.addDays(today, -randBetween(1, 3000));
orders.push({
id: i,
date: wjCore.DateTime.addDays(shipped, -randBetween(1, 5)),
shippedDate: shipped,
amount: randBetween(10000, 500000) / 100,
customer: clone(randArray(customers)),
shipper: clone(randArray(shippers))
});
}
function randBetween(min, max) {
return Math.floor(Math.random() * (max - min + 1) + min);
}
function randArray(arr) {
return arr[randBetween(0, arr.length - 1)];
}
// shallow copy
function clone(obj) {
if (wjCore.isFunction(Object.assign)) { // IE does not support it
return Object.assign({}, obj);
}
let clone = {};
for (let prop in obj) {
if (obj.hasOwnProperty(prop)) {
clone[prop] = obj[prop];
}
}
return clone;
}
// expose orders CollectionView to the app
appData.orders = new wjCore.CollectionView(orders);
// expose grouped orders CollectionView to the app
appData.groupedOrders = new wjCore.CollectionView(orders, {
groupDescriptions: [
'customer.city'
]
});
// expose paged orders CollectionView to the app
appData.pagedOrders = new wjCore.CollectionView(orders, {
pageSize: 4
});
// expose addNew oders CollectionView to the app
appData.addNewOrders = new wjCore.CollectionView(orders, {
newItemCreator: function () {
return {
customer: {},
shipper: {}
};
},
});
appData.addNewOrders.moveCurrentToLast();
// refresh views when data source changes
let ordersRefreshing = false;
appData.orders.collectionChanged.addHandler(function () {
ordersRefreshing = true;
if (!pagedOrdersRefreshing) {
appData.pagedOrders.refresh();
}
if (!groupedOrdersRefreshing) {
appData.groupedOrders.refresh();
}
if (!addNewOrdersRefreshing) {
appData.addNewOrders.refresh();
}
ordersRefreshing = false;
});
// addNew orders
let addNewOrdersRefreshing = false;
appData.addNewOrders.collectionChanged.addHandler(function () {
addNewOrdersRefreshing = true;
if (!ordersRefreshing) {
appData.orders.refresh();
}
if (!pagedOrdersRefreshing) {
appData.pagedOrders.refresh();
}
if (!groupedOrdersRefreshing) {
appData.groupedOrders.refresh();
}
addNewOrdersRefreshing = false;
});
// grouped orders
let groupedOrdersRefreshing = false;
appData.groupedOrders.collectionChanged.addHandler(function () {
groupedOrdersRefreshing = true;
if (!ordersRefreshing) {
appData.orders.refresh();
}
if (!pagedOrdersRefreshing) {
appData.pagedOrders.refresh();
}
if (!addNewOrdersRefreshing) {
appData.addNewOrders.refresh();
}
groupedOrdersRefreshing = false;
});
// paged orders
let pagedOrdersRefreshing = false;
appData.pagedOrders.collectionChanged.addHandler(function () {
pagedOrdersRefreshing = true;
if (!ordersRefreshing) {
appData.orders.refresh();
}
if (!addNewOrdersRefreshing) {
appData.addNewOrders.refresh();
}
if (!groupedOrdersRefreshing) {
appData.groupedOrders.refresh();
}
pagedOrdersRefreshing = false;
});
// sample layout definitions
appData.ldOneLine = [
{ cells: [{ binding: 'id', header: 'ID', cssClass: 'id', isReadOnly: true }] },
{ cells: [{ binding: 'date', header: 'Ordered' }] },
{ cells: [{ binding: 'shippedDate', header: 'Shipped' }] },
{ cells: [{ binding: 'amount', header: 'Amount', format: 'c', cssClass: 'amount' }] },
{ cells: [{ binding: 'customer.name', header: 'Customer' }] },
{ cells: [{ binding: 'customer.address', header: 'Address', wordWrap: true }] },
{ cells: [{ binding: 'customer.city', header: 'City', dataMap: cityMap }] },
{ cells: [{ binding: 'customer.state', header: 'State', width: 45 }] },
{ cells: [{ binding: 'customer.zip', header: 'Zip' }] },
{ cells: [{ binding: 'customer.email', header: 'Customer Email', cssClass: 'email' }] },
{ cells: [{ binding: 'customer.phone', header: 'Customer Phone' }] },
{ cells: [{ binding: 'shipper.name', header: 'Shipper' }] },
{ cells: [{ binding: 'shipper.email', header: 'Shipper Email', cssClass: 'email' }] },
{ cells: [{ binding: 'shipper.phone', header: 'Shipper Phone' }] },
{ cells: [{ binding: 'shipper.express', header: 'Express' }] }
];
appData.ldThreeLines = [
{
header: 'Order', colspan: 3, cells: [
{ binding: 'id', header: 'ID', rowspan: 2, cssClass: 'id' },
{ binding: 'amount', header: 'Amount', format: 'c', rowspan: 2, cssClass: 'amount' },
{ binding: 'date', header: 'Ordered' },
{ binding: 'shippedDate', header: 'Shipped' }
]
},
{
header: 'Customer', colspan: 3, cells: [
{ binding: 'customer.name', header: 'Name' },
{ binding: 'customer.address', header: 'Address', rowspan: 2 },
{ binding: 'customer.city', header: 'City', dataMap: cityMap },
{ binding: 'customer.email', header: 'EMail', rowspan: 2, cssClass: 'email' },
{ binding: 'customer.state', header: 'State', width: 45 },
{ binding: 'customer.phone', header: 'Phone' },
{ binding: 'customer.zip', header: 'Zip' },
]
},
{
header: 'Shipper', colspan: 3, cells: [
{ binding: 'shipper.name', header: 'Shipper' },
{ binding: 'shipper.email', header: 'EMail', cssClass: 'email' },
{ binding: 'shipper.express', header: 'Express' }
]
}
];
appData.layoutDefs = new wjCore.CollectionView([
{
name: 'Basic layout',
descriptions: {
main: 'This layout is divided into three groups: order, customer, and shipper. Each group consists of multiple properties and spans three columns.',
transposedView: 'This view uses three columns per record, and different number of rows per group.',
ordinaryView: 'This view uses the same number of rows per record, and three columns per group.'
},
def: appData.ldThreeLines
},
{
name: 'Grid layout',
descriptions: {
main: 'This layout is like a grid view. Each group consists of single property and spans one column.',
transposedView: 'This view corresponds to transposed grid view in which columns represent records.',
ordinaryView: 'This view corresponds to traditional grid view in which rows represent records.'
},
def: appData.ldOneLine
}
]);
return appData;
}
export const data = getData();
(function (global) {
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.52-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'cdn:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.react.chart.analytics': 'cdn:@mescius/wijmo.react.chart.analytics/index.js',
'@mescius/wijmo.react.chart.animation': 'cdn:@mescius/wijmo.react.chart.animation/index.js',
'@mescius/wijmo.react.chart.annotation': 'cdn:@mescius/wijmo.react.chart.annotation/index.js',
'@mescius/wijmo.react.chart.finance.analytics': 'cdn:@mescius/wijmo.react.chart.finance.analytics/index.js',
'@mescius/wijmo.react.chart.finance': 'cdn:@mescius/wijmo.react.chart.finance/index.js',
'@mescius/wijmo.react.chart.hierarchical': 'cdn:@mescius/wijmo.react.chart.hierarchical/index.js',
'@mescius/wijmo.react.chart.interaction': 'cdn:@mescius/wijmo.react.chart.interaction/index.js',
'@mescius/wijmo.react.chart.radar': 'cdn:@mescius/wijmo.react.chart.radar/index.js',
'@mescius/wijmo.react.chart': 'cdn:@mescius/wijmo.react.chart/index.js',
'@mescius/wijmo.react.core': 'cdn:@mescius/wijmo.react.core/index.js',
'@mescius/wijmo.react.chart.map': 'cdn:@mescius/wijmo.react.chart.map/index.js',
'@mescius/wijmo.react.gauge': 'cdn:@mescius/wijmo.react.gauge/index.js',
'@mescius/wijmo.react.grid.detail': 'cdn:@mescius/wijmo.react.grid.detail/index.js',
'@mescius/wijmo.react.grid.filter': 'cdn:@mescius/wijmo.react.grid.filter/index.js',
'@mescius/wijmo.react.grid.grouppanel': 'cdn:@mescius/wijmo.react.grid.grouppanel/index.js',
'@mescius/wijmo.react.grid.search': 'cdn:@mescius/wijmo.react.grid.search/index.js',
'@mescius/wijmo.react.grid.multirow': 'cdn:@mescius/wijmo.react.grid.multirow/index.js',
'@mescius/wijmo.react.grid.sheet': 'cdn:@mescius/wijmo.react.grid.sheet/index.js',
'@mescius/wijmo.react.grid.transposed': 'cdn:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'cdn:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'cdn:@mescius/wijmo.react.grid.immutable/index.js',
'@mescius/wijmo.react.grid': 'cdn:@mescius/wijmo.react.grid/index.js',
'@mescius/wijmo.react.input': 'cdn:@mescius/wijmo.react.input/index.js',
'@mescius/wijmo.react.olap': 'cdn:@mescius/wijmo.react.olap/index.js',
'@mescius/wijmo.react.viewer': 'cdn:@mescius/wijmo.react.viewer/index.js',
'@mescius/wijmo.react.nav': 'cdn:@mescius/wijmo.react.nav/index.js',
'@mescius/wijmo.react.base': 'cdn:@mescius/wijmo.react.base/index.js',
'@mescius/wijmo.react.barcode.common': 'cdn:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'cdn:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'cdn:@mescius/wijmo.react.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
react: 'pcdn:react@19.0.0/index.js',
'react-dom': 'pcdn:react-dom@19.0.0/index.js',
'react-dom/client': 'pcdn:react-dom@19.0.0/client.js',
scheduler: 'pcdn:scheduler@0.25.0/index.js',
redux: 'pcdn:redux@5.0.1/dist/redux.legacy-esm.js',
'react-redux': 'pcdn:react-redux@9.2.0/dist/react-redux.legacy-esm.js',
'bootstrap.css': 'pcdn:bootstrap@5.3.8/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
'react-use-event-hook': 'pcdn:react-use-event-hook@0.9.6/dist/esm/useEvent.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);

<template>
<div class="container-fluid">
<label>
Layout option:
<wj-combo-box :itemsSource="layoutDefs" :displayMemberPath="'name'" v-model="currentLayout" />
</label>
<p>{{ currentLayout.descriptions.main }}</p>
<label>Transposed MultiRow</label>
<p>{{ currentLayout.descriptions.transposedView }}</p>
<wj-transposed-multi-row :itemsSource="orders" :layoutDefinition="currentLayout.def"
:initialized="gridInitialized" />
<div>
<button @click="exportToExcel" class="btn btn-outline-secondary">
Export To Excel
</button>
<button @click="exportToPdf" class="btn btn-outline-secondary">
Export To PDF
</button>
</div>
<label>Ordinary MultiRow</label>
<p>{{ currentLayout.descriptions.ordinaryView }}</p>
<wj-multi-row :itemsSource="orders" :layoutDefinition="currentLayout.def" />
</div>
</template>
<script setup>
import * as wjPdf from "@mescius/wijmo.pdf";
import * as wjXlsx from "@mescius/wijmo.xlsx";
import * as wjGridPdf from "@mescius/wijmo.grid.pdf";
import * as wjGridXlsx from "@mescius/wijmo.grid.xlsx";
import { getData } from "./data";
import { ref } from "vue";
const orders = ref(null);
const layoutDefs = ref(null);
const currentLayout = ref(null);
const trnMultirow = ref(null);
let appData = getData();
orders.value = appData.orders;
layoutDefs.value = appData.layoutDefs;
currentLayout.value = appData.layoutDefs.currentItem;
function gridInitialized(ctl) {
trnMultirow.value = ctl;
}
function exportToExcel() {
wjGridXlsx.FlexGridXlsxConverter.saveAsync(
trnMultirow.value,
{
includeRowHeaders: true,
},
"FlexGrid.xlsx",
);
}
function exportToPdf() {
wjGridPdf.FlexGridPdfConverter.export(trnMultirow.value, "FlexGrid.pdf", {
documentOptions: {
pageSettings: {
layout: wjPdf.PdfPageOrientation.Landscape,
},
},
scaleMode: wjGridPdf.ScaleMode.ActualSize,
});
}
</script>
<style>
.wj-transposed-multirow {
height: 300px;
margin: 6px 0;
}
.wj-multirow {
height: 400px;
margin: 6px 0;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo TransposedMultiRow Layout Definition</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
import * as wjCore from '@mescius/wijmo';
import * as wjGrid from '@mescius/wijmo.grid'
export function getData() {
// create some data
let appData = {},
customers = [],
firstNames = 'Aaron,Paul,John,Mark,Sue,Tom,Bill,Joe,Tony,Brad,Frank,Chris,Pat'.split(','),
lastNames = 'Smith,Johnson,Richards,Bannon,Wong,Peters,White,Brown,Adams,Jennings'.split(','),
cities = 'York,Paris,Rome,Cairo,Florence,Sidney,Hamburg,Vancouver'.split(','),
states = 'SP,RS,RN,SC,CS,RT,BC'.split(',');
for (let i = 0; i < 50; i++) {
let first = randArray(firstNames),
last = randArray(lastNames);
customers.push({
id: i,
name: first + ' ' + last,
address: randBetween(100, 10000) + ' ' + randArray(lastNames) + ' St.',
city: randArray(cities),
state: randArray(states),
zip: wjCore.format('{p1:d5}-{p2:d3}', {
p1: randBetween(10000, 99999),
p2: randBetween(100, 999)
}),
email: first + '.' + last + '@gmail.com',
phone: wjCore.format('{p1:d3}-{p2:d4}', {
p1: randBetween(100, 999),
p2: randBetween(1000, 9999)
})
});
}
let cityMap = new wjGrid.DataMap(cities);
let shippers = [
{ id: 0, name: 'Speedy Express', email: 'speedy@gmail.com', phone: '431-3234', express: true },
{ id: 1, name: 'Flash Delivery', email: 'flash@gmail.com', phone: '431-6563', express: true },
{ id: 2, name: 'Logitrax', email: 'logitrax@gmail.com', phone: '431-3981', express: false },
{ id: 3, name: 'Acme Inc', email: 'acme@gmail.com', phone: '431-3113', express: false }
];
let orders = [];
let today = new Date();
for (let i = 0; i < 20; i++) {
let shipped = wjCore.DateTime.addDays(today, -randBetween(1, 3000));
orders.push({
id: i,
date: wjCore.DateTime.addDays(shipped, -randBetween(1, 5)),
shippedDate: shipped,
amount: randBetween(10000, 500000) / 100,
customer: clone(randArray(customers)),
shipper: clone(randArray(shippers))
});
}
function randBetween(min, max) {
return Math.floor(Math.random() * (max - min + 1) + min);
}
function randArray(arr) {
return arr[randBetween(0, arr.length - 1)];
}
// shallow copy
function clone(obj) {
if (wjCore.isFunction(Object.assign)) { // IE does not support it
return Object.assign({}, obj);
}
let clone = {};
for (let prop in obj) {
if (obj.hasOwnProperty(prop)) {
clone[prop] = obj[prop];
}
}
return clone;
}
// expose orders CollectionView to the app
appData.orders = new wjCore.CollectionView(orders);
// expose grouped orders CollectionView to the app
appData.groupedOrders = new wjCore.CollectionView(orders, {
groupDescriptions: [
'customer.city'
]
});
// expose paged orders CollectionView to the app
appData.pagedOrders = new wjCore.CollectionView(orders, {
pageSize: 4
});
// expose addNew oders CollectionView to the app
appData.addNewOrders = new wjCore.CollectionView(orders, {
newItemCreator: function () {
return { // add empty customer and shipper objects to new orders
customer: {},
shipper: {}
}
},
});
appData.addNewOrders.moveCurrentToLast();
// refresh views when data source changes
let ordersRefreshing = false;
appData.orders.collectionChanged.addHandler(function () {
ordersRefreshing = true;
if (!pagedOrdersRefreshing) {
appData.pagedOrders.refresh();
}
if (!groupedOrdersRefreshing) {
appData.groupedOrders.refresh();
}
if (!addNewOrdersRefreshing) {
appData.addNewOrders.refresh();
}
ordersRefreshing = false;
});
// addNew orders
let addNewOrdersRefreshing = false;
appData.addNewOrders.collectionChanged.addHandler(function () {
addNewOrdersRefreshing = true;
if (!ordersRefreshing) {
appData.orders.refresh();
}
if (!pagedOrdersRefreshing) {
appData.pagedOrders.refresh();
}
if (!groupedOrdersRefreshing) {
appData.groupedOrders.refresh();
}
addNewOrdersRefreshing = false;
});
// grouped orders
let groupedOrdersRefreshing = false;
appData.groupedOrders.collectionChanged.addHandler(function () {
groupedOrdersRefreshing = true;
if (!ordersRefreshing) {
appData.orders.refresh();
}
if (!pagedOrdersRefreshing) {
appData.pagedOrders.refresh();
}
if (!addNewOrdersRefreshing) {
appData.addNewOrders.refresh();
}
groupedOrdersRefreshing = false;
});
// paged orders
let pagedOrdersRefreshing = false;
appData.pagedOrders.collectionChanged.addHandler(function () {
pagedOrdersRefreshing = true;
if (!ordersRefreshing) {
appData.orders.refresh();
}
if (!addNewOrdersRefreshing) {
appData.addNewOrders.refresh();
}
if (!groupedOrdersRefreshing) {
appData.groupedOrders.refresh();
}
pagedOrdersRefreshing = false;
});
// sample layout definitions
appData.ldOneLine = [
{ cells: [{ binding: 'id', header: 'ID', cssClass: 'id', isReadOnly: true }] },
{ cells: [{ binding: 'date', header: 'Ordered' }] },
{ cells: [{ binding: 'shippedDate', header: 'Shipped' }] },
{ cells: [{ binding: 'amount', header: 'Amount', format: 'c', cssClass: 'amount' }] },
{ cells: [{ binding: 'customer.name', header: 'Customer' }] },
{ cells: [{ binding: 'customer.address', header: 'Address', wordWrap: true }] },
{ cells: [{ binding: 'customer.city', header: 'City', dataMap: cityMap }] },
{ cells: [{ binding: 'customer.state', header: 'State', width: 45 }] },
{ cells: [{ binding: 'customer.zip', header: 'Zip' }] },
{ cells: [{ binding: 'customer.email', header: 'Customer Email', cssClass: 'email' }] },
{ cells: [{ binding: 'customer.phone', header: 'Customer Phone' }] },
{ cells: [{ binding: 'shipper.name', header: 'Shipper' }] },
{ cells: [{ binding: 'shipper.email', header: 'Shipper Email', cssClass: 'email' }] },
{ cells: [{ binding: 'shipper.phone', header: 'Shipper Phone' }] },
{ cells: [{ binding: 'shipper.express', header: 'Express' }] }
];
appData.ldThreeLines = [
{
header: 'Order', colspan: 3, cells: [
{ binding: 'id', header: 'ID', rowspan: 2, cssClass: 'id' },
{ binding: 'amount', header: 'Amount', format: 'c', rowspan: 2, cssClass: 'amount' },
{ binding: 'date', header: 'Ordered' },
{ binding: 'shippedDate', header: 'Shipped' }
]
},
{
header: 'Customer', colspan: 3, cells: [
{ binding: 'customer.name', header: 'Name' },
{ binding: 'customer.address', header: 'Address', rowspan: 2 },
{ binding: 'customer.city', header: 'City', dataMap: cityMap },
{ binding: 'customer.email', header: 'EMail', rowspan: 2, cssClass: 'email' },
{ binding: 'customer.state', header: 'State', width: 45 },
{ binding: 'customer.phone', header: 'Phone' },
{ binding: 'customer.zip', header: 'Zip' },
]
},
{
header: 'Shipper', colspan: 3, cells: [
{ binding: 'shipper.name', header: 'Shipper' },
{ binding: 'shipper.email', header: 'EMail', cssClass: 'email' },
{ binding: 'shipper.express', header: 'Express' }
]
}
];
appData.layoutDefs = new wjCore.CollectionView([
{
name: 'Basic layout',
descriptions: {
main: 'This layout is divided into three groups: order, customer, and shipper. Each group consists of multiple properties and spans three columns.',
transposedView: 'This view uses three columns per record, and different number of rows per group.',
ordinaryView: 'This view uses the same number of rows per record, and three columns per group.'
},
def: appData.ldThreeLines
},
{
name: 'Grid layout',
descriptions: {
main: 'This layout is like a grid view. Each group consists of single property and spans one column.',
transposedView: 'This view corresponds to transposed grid view in which columns represent records.',
ordinaryView: 'This view corresponds to traditional grid view in which rows represent records.'
},
def: appData.ldOneLine
}
]);
return appData;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' },
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.52-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.vue2.chart.analytics': 'cdn:@mescius/wijmo.vue2.chart.analytics/index.js',
'@mescius/wijmo.vue2.chart.animation': 'cdn:@mescius/wijmo.vue2.chart.animation/index.js',
'@mescius/wijmo.vue2.chart.annotation': 'cdn:@mescius/wijmo.vue2.chart.annotation/index.js',
'@mescius/wijmo.vue2.chart.finance.analytics': 'cdn:@mescius/wijmo.vue2.chart.finance.analytics/index.js',
'@mescius/wijmo.vue2.chart.finance': 'cdn:@mescius/wijmo.vue2.chart.finance/index.js',
'@mescius/wijmo.vue2.chart.hierarchical': 'cdn:@mescius/wijmo.vue2.chart.hierarchical/index.js',
'@mescius/wijmo.vue2.chart.interaction': 'cdn:@mescius/wijmo.vue2.chart.interaction/index.js',
'@mescius/wijmo.vue2.chart.radar': 'cdn:@mescius/wijmo.vue2.chart.radar/index.js',
'@mescius/wijmo.vue2.chart.map': 'cdn:@mescius/wijmo.vue2.chart.map/index.js',
'@mescius/wijmo.vue2.chart': 'cdn:@mescius/wijmo.vue2.chart/index.js',
'@mescius/wijmo.vue2.core': 'cdn:@mescius/wijmo.vue2.core/index.js',
'@mescius/wijmo.vue2.gauge': 'cdn:@mescius/wijmo.vue2.gauge/index.js',
'@mescius/wijmo.vue2.grid.detail': 'cdn:@mescius/wijmo.vue2.grid.detail/index.js',
'@mescius/wijmo.vue2.grid.filter': 'cdn:@mescius/wijmo.vue2.grid.filter/index.js',
'@mescius/wijmo.vue2.grid.grouppanel': 'cdn:@mescius/wijmo.vue2.grid.grouppanel/index.js',
'@mescius/wijmo.vue2.grid.search': 'cdn:@mescius/wijmo.vue2.grid.search/index.js',
'@mescius/wijmo.vue2.grid.multirow': 'cdn:@mescius/wijmo.vue2.grid.multirow/index.js',
'@mescius/wijmo.vue2.grid.sheet': 'cdn:@mescius/wijmo.vue2.grid.sheet/index.js',
'@mescius/wijmo.vue2.grid.transposed': 'cdn:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'cdn:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
'@mescius/wijmo.vue2.grid': 'cdn:@mescius/wijmo.vue2.grid/index.js',
'@mescius/wijmo.vue2.input': 'cdn:@mescius/wijmo.vue2.input/index.js',
'@mescius/wijmo.vue2.olap': 'cdn:@mescius/wijmo.vue2.olap/index.js',
'@mescius/wijmo.vue2.viewer': 'cdn:@mescius/wijmo.vue2.viewer/index.js',
'@mescius/wijmo.vue2.nav': 'cdn:@mescius/wijmo.vue2.nav/index.js',
'@mescius/wijmo.vue2.base': 'cdn:@mescius/wijmo.vue2.base/index.js',
'@mescius/wijmo.vue2.barcode.common': 'cdn:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'cdn:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'cdn:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@5.3.8/dist/css/bootstrap.min.css',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
vue: 'pcdn:vue@3.4.21/dist/vue.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'vue-loader': 'pcdn:systemjs-vue-browser@1.0.11/index.js',
//'systemjs-plugin-vue': 'pcdn:systemjs-plugin-vue@1.2.0/index.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
rxjs: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import '@angular/compiler';
import { Component, Inject, enableProdMode, ViewChild, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { WjInputModule } from '@mescius/wijmo.angular2.input';
import { WjGridMultirowModule } from '@mescius/wijmo.angular2.grid.multirow';
import { WjGridTransposedmultirowModule } from '@mescius/wijmo.angular2.grid.transposedmultirow';
import * as wjPdf from '@mescius/wijmo.pdf';
import * as wjXlsx from '@mescius/wijmo.xlsx';
import * as wjGridPdf from '@mescius/wijmo.grid.pdf';
import * as wjGridXlsx from '@mescius/wijmo.grid.xlsx';
import { TransposedMultiRow } from '@mescius/wijmo.grid.transposedmultirow';
import { DataService } from './app.data';
//
@Component({
standalone: true,
providers: [DataService],
imports: [BrowserModule, WjInputModule, WjGridMultirowModule, WjGridTransposedmultirowModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
orders: any;
layoutDefs: any;
currentLayout: any;
//
@ViewChild('trnMultirow', { static: true }) trnMultirow: TransposedMultiRow;
//
constructor(@Inject(DataService) dataService: DataService) {
let appData = dataService.getData();
this.orders = appData.orders;
this.layoutDefs = appData.layoutDefs;
this.currentLayout = appData.layoutDefs.currentItem;
}
exportToExcel() {
wjGridXlsx.FlexGridXlsxConverter.saveAsync(
this.trnMultirow,
{
includeRowHeaders: true,
},
'FlexGrid.xlsx',
);
}
exportToPdf() {
wjGridPdf.FlexGridPdfConverter.export(this.trnMultirow, 'FlexGrid.pdf', {
documentOptions: {
pageSettings: {
layout: wjPdf.PdfPageOrientation.Landscape,
},
},
scaleMode: wjGridPdf.ScaleMode.ActualSize,
});
}
}
//
//
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo TransposedMultiRow Layout Definition</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="https://cdn.jsdelivr.net/npm/core-js/client/shim.min.js"></script>
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<label>Layout option:
<wj-combo-box
[itemsSource]="layoutDefs"
[displayMemberPath]="'name'"
[(selectedValue)]="currentLayout">
</wj-combo-box>
</label>
<p>{{currentLayout.descriptions.main}}</p>
<label>Transposed MultiRow</label>
<p>{{currentLayout.descriptions.transposedView}}</p>
<wj-transposed-multi-row #trnMultirow
[itemsSource]="orders"
[layoutDefinition]="currentLayout.def">
</wj-transposed-multi-row>
<div>
<button (click)="exportToExcel()" class="btn btn-outline-secondary">
Export To Excel
</button>
<button (click)="exportToPdf()" class="btn btn-outline-secondary">
Export To PDF
</button>
</div>
<label>Ordinary MultiRow</label>
<p>{{currentLayout.descriptions.ordinaryView}}</p>
<wj-multi-row
[itemsSource]="orders"
[layoutDefinition]="currentLayout.def">
</wj-multi-row>
</div>
import { Injectable } from '@angular/core';
import * as wjCore from '@mescius/wijmo';
import * as wjGrid from '@mescius/wijmo.grid';
interface Cell {
binding: string;
header: string;
cssClass?: string;
format?: string;
isReadOnly?: boolean;
wordWrap?: boolean;
width: number;
}
interface Line {
Cells: Cell[];
header?: string;
colspan?: number;
}
export interface AppData {
orders: wjCore.CollectionView;
groupedOrders: wjCore.CollectionView;
pagedOrders: wjCore.CollectionView;
addNewOrders: wjCore.CollectionView;
ldOneLine: Cell[];
ldTwoLines: Line[];
ldThreeLines: Line[];
layoutDefs: wjCore.CollectionView;
}
@Injectable()
export class DataService {
getData(): AppData {
// create some data
let appData: any = {},
customers = [],
firstNames = 'Aaron,Paul,John,Mark,Sue,Tom,Bill,Joe,Tony,Brad,Frank,Chris,Pat'.split(','),
lastNames = 'Smith,Johnson,Richards,Bannon,Wong,Peters,White,Brown,Adams,Jennings'.split(','),
cities = 'York,Paris,Rome,Cairo,Florence,Sidney,Hamburg,Vancouver'.split(','),
states = 'SP,RS,RN,SC,CS,RT,BC'.split(',');
for (let i = 0; i < 50; i++) {
let first = randArray(firstNames),
last = randArray(lastNames);
customers.push({
id: i,
name: first + ' ' + last,
address: randBetween(100, 10000) + ' ' + randArray(lastNames) + ' St.',
city: randArray(cities),
state: randArray(states),
zip: wjCore.format('{p1:d5}-{p2:d3}', {
p1: randBetween(10000, 99999),
p2: randBetween(100, 999)
}),
email: first + '.' + last + '@gmail.com',
phone: wjCore.format('{p1:d3}-{p2:d4}', {
p1: randBetween(100, 999),
p2: randBetween(1000, 9999)
})
});
}
let cityMap = new wjGrid.DataMap(cities);
let shippers = [
{ id: 0, name: 'Speedy Express', email: 'speedy@gmail.com', phone: '431-3234', express: true },
{ id: 1, name: 'Flash Delivery', email: 'flash@gmail.com', phone: '431-6563', express: true },
{ id: 2, name: 'Logitrax', email: 'logitrax@gmail.com', phone: '431-3981', express: false },
{ id: 3, name: 'Acme Inc', email: 'acme@gmail.com', phone: '431-3113', express: false }
];
let orders = [];
let today = new Date();
for (let i = 0; i < 20; i++) {
let shipped = wjCore.DateTime.addDays(today, -randBetween(1, 3000));
orders.push({
id: i,
date: wjCore.DateTime.addDays(shipped, -randBetween(1, 5)),
shippedDate: shipped,
amount: randBetween(10000, 500000) / 100,
customer: clone(randArray(customers)),
shipper: clone(randArray(shippers))
});
}
function randBetween(min: number, max: number) {
return Math.floor(Math.random() * (max - min + 1) + min);
}
function randArray(arr: any[]) {
return arr[randBetween(0, arr.length - 1)];
}
// shallow copy
function clone(obj: any) {
if (wjCore.isFunction(Object.assign)) { // IE does not support it
return Object.assign({}, obj);
}
let clone = {};
for (let prop in obj) {
if (obj.hasOwnProperty(prop)) {
clone[prop] = obj[prop];
}
}
return clone;
}
// expose orders CollectionView to the app
appData.orders = new wjCore.CollectionView(orders);
// expose grouped orders CollectionView to the app
appData.groupedOrders = new wjCore.CollectionView(orders, {
groupDescriptions: [
'customer.city'
]
});
// expose paged orders CollectionView to the app
appData.pagedOrders = new wjCore.CollectionView(orders, {
pageSize: 4
});
// expose addNew oders CollectionView to the app
appData.addNewOrders = new wjCore.CollectionView(orders, {
newItemCreator: function () {
return { // add empty customer and shipper objects to new orders
customer: {},
shipper: {}
}
},
});
appData.addNewOrders.moveCurrentToLast();
// refresh views when data source changes
let ordersRefreshing = false;
appData.orders.collectionChanged.addHandler(function () {
ordersRefreshing = true;
if (!pagedOrdersRefreshing) {
appData.pagedOrders.refresh();
}
if (!groupedOrdersRefreshing) {
appData.groupedOrders.refresh();
}
if (!addNewOrdersRefreshing) {
appData.addNewOrders.refresh();
}
ordersRefreshing = false;
});
// addNew orders
let addNewOrdersRefreshing = false;
appData.addNewOrders.collectionChanged.addHandler(function () {
addNewOrdersRefreshing = true;
if (!ordersRefreshing) {
appData.orders.refresh();
}
if (!pagedOrdersRefreshing) {
appData.pagedOrders.refresh();
}
if (!groupedOrdersRefreshing) {
appData.groupedOrders.refresh();
}
addNewOrdersRefreshing = false;
});
// grouped orders
let groupedOrdersRefreshing = false;
appData.groupedOrders.collectionChanged.addHandler(function () {
groupedOrdersRefreshing = true;
if (!ordersRefreshing) {
appData.orders.refresh();
}
if (!pagedOrdersRefreshing) {
appData.pagedOrders.refresh();
}
if (!addNewOrdersRefreshing) {
appData.addNewOrders.refresh();
}
groupedOrdersRefreshing = false;
});
// paged orders
let pagedOrdersRefreshing = false;
appData.pagedOrders.collectionChanged.addHandler(function () {
pagedOrdersRefreshing = true;
if (!ordersRefreshing) {
appData.orders.refresh();
}
if (!addNewOrdersRefreshing) {
appData.addNewOrders.refresh();
}
if (!groupedOrdersRefreshing) {
appData.groupedOrders.refresh();
}
pagedOrdersRefreshing = false;
});
// sample layout definitions
appData.ldOneLine = [
{ cells: [{ binding: 'id', header: 'ID', cssClass: 'id', isReadOnly: true }] },
{ cells: [{ binding: 'date', header: 'Ordered' }] },
{ cells: [{ binding: 'shippedDate', header: 'Shipped' }] },
{ cells: [{ binding: 'amount', header: 'Amount', format: 'c', cssClass: 'amount' }] },
{ cells: [{ binding: 'customer.name', header: 'Customer' }] },
{ cells: [{ binding: 'customer.address', header: 'Address', wordWrap: true }] },
{ cells: [{ binding: 'customer.city', header: 'City', dataMap: cityMap }] },
{ cells: [{ binding: 'customer.state', header: 'State', width: 45 }] },
{ cells: [{ binding: 'customer.zip', header: 'Zip' }] },
{ cells: [{ binding: 'customer.email', header: 'Customer Email', cssClass: 'email' }] },
{ cells: [{ binding: 'customer.phone', header: 'Customer Phone' }] },
{ cells: [{ binding: 'shipper.name', header: 'Shipper' }] },
{ cells: [{ binding: 'shipper.email', header: 'Shipper Email', cssClass: 'email' }] },
{ cells: [{ binding: 'shipper.phone', header: 'Shipper Phone' }] },
{ cells: [{ binding: 'shipper.express', header: 'Express' }] }
];
appData.ldThreeLines = [
{
header: 'Order', colspan: 3, cells: [
{ binding: 'id', header: 'ID', rowspan: 2, cssClass: 'id' },
{ binding: 'amount', header: 'Amount', format: 'c', rowspan: 2, cssClass: 'amount' },
{ binding: 'date', header: 'Ordered' },
{ binding: 'shippedDate', header: 'Shipped' }
]
},
{
header: 'Customer', colspan: 3, cells: [
{ binding: 'customer.name', header: 'Name' },
{ binding: 'customer.address', header: 'Address', rowspan: 2 },
{ binding: 'customer.city', header: 'City', dataMap: cityMap },
{ binding: 'customer.email', header: 'EMail', rowspan: 2, cssClass: 'email' },
{ binding: 'customer.state', header: 'State', width: 45 },
{ binding: 'customer.phone', header: 'Phone' },
{ binding: 'customer.zip', header: 'Zip' },
]
},
{
header: 'Shipper', colspan: 3, cells: [
{ binding: 'shipper.name', header: 'Shipper' },
{ binding: 'shipper.email', header: 'EMail', cssClass: 'email' },
{ binding: 'shipper.express', header: 'Express' }
]
}
];
appData.layoutDefs = new wjCore.CollectionView([
{
name: 'Basic layout',
descriptions: {
main: 'This layout is divided into three groups: order, customer, and shipper. Each group consists of multiple properties and spans three columns.',
transposedView: 'This view uses three columns per record, and different number of rows per group.',
ordinaryView: 'This view uses the same number of rows per record, and three columns per group.'
},
def: appData.ldThreeLines
},
{
name: 'Grid layout',
descriptions: {
main: 'This layout is like a grid view. Each group consists of single property and spans one column.',
transposedView: 'This view corresponds to transposed grid view in which columns represent records.',
ordinaryView: 'This view corresponds to traditional grid view in which rows represent records.'
},
def: appData.ldOneLine
}
]);
return appData;
}
}
.wj-transposed-multirow {
height: 300px;
margin: 6px 0;
}
.wj-multirow {
height: 400px;
margin: 6px 0;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
target: 'ES2022',
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
typescript: {
exports: 'ts',
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm',
},
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.52-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/',
'agpcdn:': 'https://cdn.jsdelivr.net/npm/'
},
packageConfigPaths: ['/node_modules/*/package.json', '/node_modules/@angular/*/package.json', '/node_modules/@mescius/*/package.json'],
map: {
'core-js': 'agpcdn:core-js@2.6.12/client/shim.min.js',
'typescript': 'agpcdn:typescript@5.9.3/lib/typescript.min.js',
rxjs: 'agpcdn:rxjs@7.8.1/dist/bundles/rxjs.umd.min.js',
'systemjs-plugin-css': 'agpcdn:systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.angular2.chart.analytics': 'cdn:@mescius/wijmo.angular2.chart.analytics/index.js',
'@mescius/wijmo.angular2.chart.animation': 'cdn:@mescius/wijmo.angular2.chart.animation/index.js',
'@mescius/wijmo.angular2.chart.annotation': 'cdn:@mescius/wijmo.angular2.chart.annotation/index.js',
'@mescius/wijmo.angular2.chart.finance.analytics': 'cdn:@mescius/wijmo.angular2.chart.finance.analytics/index.js',
'@mescius/wijmo.angular2.chart.finance': 'cdn:@mescius/wijmo.angular2.chart.finance/index.js',
'@mescius/wijmo.angular2.chart.hierarchical': 'cdn:@mescius/wijmo.angular2.chart.hierarchical/index.js',
'@mescius/wijmo.angular2.chart.interaction': 'cdn:@mescius/wijmo.angular2.chart.interaction/index.js',
'@mescius/wijmo.angular2.chart.radar': 'cdn:@mescius/wijmo.angular2.chart.radar/index.js',
'@mescius/wijmo.angular2.chart.map': 'cdn:@mescius/wijmo.angular2.chart.map/index.js',
'@mescius/wijmo.angular2.chart': 'cdn:@mescius/wijmo.angular2.chart/index.js',
'@mescius/wijmo.angular2.core': 'cdn:@mescius/wijmo.angular2.core/index.js',
'@mescius/wijmo.angular2.gauge': 'cdn:@mescius/wijmo.angular2.gauge/index.js',
'@mescius/wijmo.angular2.grid.detail': 'cdn:@mescius/wijmo.angular2.grid.detail/index.js',
'@mescius/wijmo.angular2.grid.filter': 'cdn:@mescius/wijmo.angular2.grid.filter/index.js',
'@mescius/wijmo.angular2.grid.grouppanel': 'cdn:@mescius/wijmo.angular2.grid.grouppanel/index.js',
'@mescius/wijmo.angular2.grid.search': 'cdn:@mescius/wijmo.angular2.grid.search/index.js',
'@mescius/wijmo.angular2.grid.multirow': 'cdn:@mescius/wijmo.angular2.grid.multirow/index.js',
'@mescius/wijmo.angular2.grid.sheet': 'cdn:@mescius/wijmo.angular2.grid.sheet/index.js',
'@mescius/wijmo.angular2.grid.transposed': 'cdn:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'cdn:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
'@mescius/wijmo.angular2.grid': 'cdn:@mescius/wijmo.angular2.grid/index.js',
'@mescius/wijmo.angular2.input': 'cdn:@mescius/wijmo.angular2.input/index.js',
'@mescius/wijmo.angular2.olap': 'cdn:@mescius/wijmo.angular2.olap/index.js',
'@mescius/wijmo.angular2.viewer': 'cdn:@mescius/wijmo.angular2.viewer/index.js',
'@mescius/wijmo.angular2.nav': 'cdn:@mescius/wijmo.angular2.nav/index.js',
'@mescius/wijmo.angular2.directivebase': 'cdn:@mescius/wijmo.angular2.directivebase/index.js',
'@mescius/wijmo.angular2.barcode.common': 'cdn:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'cdn:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'cdn:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@5.3.8/dist/css/bootstrap.min.css',
jszip: 'agpcdn:jszip@3.10.1/dist/jszip.min.js',
'@angular/core': 'pcdn:@angular/core@21.1.0/fesm2022/core.mjs',
'@angular/core/primitives/di': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-di.mjs',
'@angular/core/primitives/signals': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-signals.mjs',
'@angular/core/primitives/event-dispatch': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-event-dispatch.mjs',
'@angular/common': 'pcdn:@angular/common@21.1.0/fesm2022/common.mjs',
'@angular/common/http': 'pcdn:@angular/common@21.1.0/fesm2022/http.mjs',
'@angular/compiler': 'pcdn:@angular/compiler@21.1.0/fesm2022/compiler.mjs',
'@angular/platform-browser': 'pcdn:@angular/platform-browser@21.1.0/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'pcdn:@angular/platform-browser-dynamic@21.1.0/fesm2022/platform-browser-dynamic.mjs',
'@angular/router': 'pcdn:@angular/router@21.1.0/fesm2022/router.mjs',
'@angular/forms': 'pcdn:@angular/forms@21.1.0/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
'./src': {
defaultExtension: 'ts',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);